/**
 * Utils javascript interface.
 * 
 * @author Alexandre C. Moraes <kalvinmoraes@gmail.com>
 */
var nivlakUtils = {
    /**
     * Config variable to set custom data.
     */
    config: {
        
    },
    /**
     * Retrieves a specific GET parameter from specified URL.
     * 
     * @param {string} $getParameter The parameter to retrieve
     * @param {string} url The URL to retrieve the GET
     * @returns {string} The specified parameter
     */
    retrieveGet: function($getParameter, url)
    {
        var $_GET = {};
        if(url === "" || url === null) {
            url = document.location.search;
        } else {
            url = "?" + url.split("?")[1];
        }
        url.replace(/\??(?:([^=]+)=([^&]*)&?)/g, function() {
            function decode(s) {
                return decodeURIComponent(s.split("+").join(" "));
            }

            $_GET[decode(arguments[1])] = decode(arguments[2]);
        });

        return $_GET[$getParameter];
    }
};